//
// The Fusion Library Interface for DOS
// Version 1.06c
// Copyright (C) 1990, 1991, 1992
// Software Dimensions
//
// FusionWindow
//

#include "fliwin.h"

#ifdef __BCPLUSPLUS__
#pragma hdrstop
#endif

#include <alloc.h>
#include <string.h>

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// FusionWindow()
//
// Constructor for FusionWindow class
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

FusionWindow::FusionWindow()
{
  NumberOfWindows=0;
  LastShift=500;
  KeyLast=500;
  Windows=0;
  DefaultHelp=0;
  MaxWindows=0;
  VirtualizeInterval=18;
  FlushMouseQueue();
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// ~FusionWindow()
//
// Destructor for FusionWindow class
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

FusionWindow::~FusionWindow()
{
  if (Windows)
  {
    for (register int i=0;i<NumberOfWindows-1;i++)
      delete Windows[i];
    free(Windows);
  }
  FlushMouseQueue();
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// TopWindow()
//
// Returns pointer to top window
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

WindowElement *FusionWindow::TopWindow()
{
  return (!NumberOfWindows)?0:Windows[0];
}

